require 'uu/os/rest/dto'
require 'uu/os/uesuri'

# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Activity
    module Activity
      # @see Activity#get_state_history_list
      class ActivityStateAttributes < UU::OS::REST::DTO

        # UESURI of the access role, which set the activity state. Nil when access role no longer exists or cannot be retrieved (on old activity states).
        attr_accessor :access_role_uri

        # Comment on the activity state.
        attr_accessor :comment

        # Activity state name. Not nil.
        attr_accessor :name

        # Activity state type. Not nil. 
        #
        # @see UU::OS::Activity::ActivityStateType
        attr_accessor :type

        # Activity state subtype. Not nil. 
        #
        # @see UU::OS::Activity::ActivityStateSubtype
        attr_accessor :subtype

        # Time when the activity state was set. Not nil.
        attr_accessor :creation_time

        # Creation stamp of the activity state. Not nil.
        attr_accessor :creation_stamp
        def access_role_uri
          attributes[:accessRoleUri]
        end

        def access_role_uri=(val)
          if val
            attributes[:accessRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:accessRoleUri] = nil
          end
        end

        def comment
          attributes[:comment]
        end

        def comment=(val)
          attributes[:comment] = val
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def type
          attributes[:type]
        end

        def type=(val)
          attributes[:type] = val
        end

        def subtype
          attributes[:subtype]
        end

        def subtype=(val)
          attributes[:subtype] = val
        end

        def creation_time
          attributes[:creationTime]
        end

        def creation_time=(val)
          attributes[:creationTime] = val
        end

        def creation_stamp
          attributes[:creationStamp]
        end

        def creation_stamp=(val)
          attributes[:creationStamp] = val
        end

      end
    end

  end
end
