require 'uu/os/rest/dto'
require 'uu/os/uesuri'


# Module Unicorn Universe.
module UU
  # Module Operating System.
  module OS
    # Module Activity Condition.
    module ActivityCondition
      # @see ActivityCondition#create
      class ActivityConditionCreate < UU::OS::REST::DTO

        # @see ActivityCondition#create
        attr_accessor :condition_code  
        
        # @see ActivityCondition#create
        attr_accessor :id  
        
        # @see ActivityCondition#create
        attr_accessor :type 
        
        # @see ActivityCondition#create
        attr_accessor :validity_type
        
        # @see ActivityCondition#create
        attr_accessor :date_of_fulfilling

        # @see ActivityCondition#create
        attr_accessor :recurring 
        
        # @see ActivityCondition#create
        attr_accessor :delay 
        
        # @see ActivityCondition#create
        attr_accessor :artifact_state_template_uri
            
        # @see ActivityCondition#create
        attr_accessor :previous_artifact_state_template_uri
        
        # @see ActivityCondition#create
        attr_accessor :activity_state_template_uri   
        
        # @see ActivityCondition#create
        attr_accessor :previous_activity_state_template_uri
        
        # @see ActivityCondition#create
        attr_accessor :expression   
        
        # @see ActivityCondition#create
        attr_accessor :condition_list

        def condition_code
           attributes[:conditionCode]
        end
        
        def condition_code=(val)           
           attributes[:conditionCode] = val 
        end         
       
        def id
           attributes[:id]
        end
       
        def id=(val)
           attributes[:id] = val
        end
        
        def type
           attributes[:type]
        end
             
        def type=(val)
           attributes[:type] = val
        end
        
        def validity_type
           attributes[:validityType]
        end
                
        def validity_type=(val)           
           attributes[:validityType] = val 
        end
        
        def date_of_fulfilling
           attributes[:dateOfFulfilling]
        end
               
        def date_of_fulfilling=(val)
           attributes[:dateOfFulfilling] = val
        end
        
        def recurring
           attributes[:recurring]
        end
              
        def recurring=(val)
           attributes[:recurring] = val
        end

        def delay
           attributes[:delay]
        end
              
        def delay=(val)
           attributes[:delay] = val
        end        
        
        def artifact_state_template_uri
           attributes[:artifactStateTemplateUri]
        end
        
        def artifact_state_template_uri=(val)
           if val
              attributes[:artifactStateTemplateUri] = UU::OS::UESURI.new(val)
           else
              attributes[:artifactStateTemplateUri] = nil
           end
        end
        
        def previous_artifact_state_template_uri
           attributes[:previousArtifactStateTemplateUri]
        end
                
        def previous_artifact_state_template_uri=(val)
           if val
              attributes[:previousArtifactStateTemplateUri] = UU::OS::UESURI.new(val)
           else
              attributes[:previousArtifactStateTemplateUri] = nil
           end
        end
        
        def activity_state_template_uri
           attributes[:activityStateTemplateUri]
        end
               
        def activity_state_template_uri=(val)
           if val
              attributes[:activityStateTemplateUri] = UU::OS::UESURI.new(val)
           else
              attributes[:activityStateTemplateUri] = nil
           end
        end
        
        def previous_activity_state_template_uri
           attributes[:previousActivityStateTemplateUri]
        end
                       
        def previous_activity_state_template_uri=(val)
           if val
              attributes[:previousActivityStateTemplateUri] = UU::OS::UESURI.new(val)
           else
              attributes[:previousActivityStateTemplateUri] = nil
           end
        end
        
        def expression
           attributes[:expression]
        end
               
        def expression=(val)
           attributes[:expression] = val
        end
        
        def condition_list
           attributes[:conditionList]
        end
               
        def condition_list=(val)           
           attributes[:conditionList] = val 
        end 

      end
    end

  end
end