require 'uu/os/rest/dto'
require 'uu/os/uesuri'



module UU
  module OS
    module AppMetaModel
      class AppMetaModelCreate < UU::OS::REST::DTO

        # @see AppMetaModel#create
        attr_accessor :meta_artifact_uri

        # @see AppMetaModel#create
        attr_accessor :code
        
        # @see AppMetaModel#create
        attr_accessor :app_box_uri

        # @see AppMetaModel#create
        attr_accessor :name

        # @see AppMetaModel#create
        attr_accessor :description

        # @see AppMetaModel#create
        attr_accessor :competent_role_uri

        # @see AppMetaModel#create
        attr_accessor :security_level

        # @see AppMetaModel#create
        attr_accessor :icon_uri
        
        # @see AppMetaModel#create
        attr_accessor :component_content

        def meta_artifact_uri
          attributes[:metaArtifactUri]
        end

        def meta_artifact_uri=(val)
          if val
            attributes[:metaArtifactUri] = UU::OS::UESURI.new(val)
          else
            attributes[:metaArtifactUri] = nil
          end
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def competent_role_uri
          attributes[:competentRoleUri]
        end

        def competent_role_uri=(val)
          if val
            attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:competentRoleUri] = nil
          end
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end
        
        def app_box_uri
          attributes[:appBoxUri]
        end

        def app_box_uri=(val)
          if val
            attributes[:appBoxUri] = UU::OS::UESURI.new(val)
          else
            attributes[:appBoxUri] = nil
          end
        end
        
        def component_content
          attributes[:componentContent]
        end
 
        def component_content=(val) 
          attributes[:componentContent] = val
        end

      end
    end

  end
end
